
'use strict';

//goog.provide('Blockly.JavaScript.tortue');

goog.require('Blockly.JavaScript');

var prefixeAlgoGGB = ""; // = "" ou = "algoGGB_"

//Géométrie de la tortue
//----------------------
//initialiser()
Blockly.JavaScript['tortue_initialisation'] = function(block) {
  var code = 'initialiser();\n';
  return code;
};
//avance(distance)
Blockly.JavaScript['tortue_avance'] = function(block) {
  var value_distance = Blockly.JavaScript.valueToCode(block, 'distance', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'avance('+value_distance+');\n';
  return code;
};
//recule(distance)
Blockly.JavaScript['tortue_recule'] = function(block) {
  var value_distance = Blockly.JavaScript.valueToCode(block, 'distance', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'recule('+value_distance+');\n';
  return code;
};
//droite(angle)
Blockly.JavaScript['tortue_droite'] = function(block) {
  var value_alpha = Blockly.JavaScript.valueToCode(block, 'alpha', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'droite('+value_alpha+');\n';
  return code;
};
//gauche(angle)
Blockly.JavaScript['tortue_gauche'] = function(block) {
  var value_alpha = Blockly.JavaScript.valueToCode(block, 'alpha', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'gauche('+value_alpha+');\n';
  return code;
};
//posX()
Blockly.JavaScript['tortue_posX'] = function(block) {
  var code = prefixeAlgoGGB+'posX()';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//posY()
Blockly.JavaScript['tortue_posY'] = function(block) {
  var code = prefixeAlgoGGB+'posY()';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//fixePos(x,y)
Blockly.JavaScript['tortue_fixePos'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixePos('+value_x+','+value_y+');\n';
  return code;
};
//sautePos(x,y)
Blockly.JavaScript['tortue_sautePos'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'sautePos('+value_x+','+value_y+');\n';
  return code;
};
//cap()
Blockly.JavaScript['tortue_cap'] = function(block) {
  var code = prefixeAlgoGGB+'cap()';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//fixeCap(angle)
Blockly.JavaScript['tortue_fixeCap'] = function(block) {
  var value_alpha = Blockly.JavaScript.valueToCode(block, 'ALPHA', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixeCap('+value_alpha+');\n';
  return code;
};
//vers(x,y)
Blockly.JavaScript['tortue_vers'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'vers('+value_x+','+value_y+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};

//Crayon
//------
//baisseCrayon()
Blockly.JavaScript['crayon_baisseCrayon'] = function(block) {
  var code = prefixeAlgoGGB+'baisseCrayon();\n';
  return code;
};
//leveCrayon()
Blockly.JavaScript['crayon_leveCrayon'] = function(block) {
  var code = prefixeAlgoGGB+'leveCrayon();\n';
  return code;
};
//fixeTailleCrayon(taille)
Blockly.JavaScript['crayon_fixeTailleCrayon'] = function(block) {
  var value_taille = Blockly.JavaScript.valueToCode(block, 'TAILLE', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixeTailleCrayon('+value_taille+');\n';
  return code;
};
//couleurCrayon(r,v,b)
Blockly.JavaScript['crayon_couleurCrayon'] = function(block) {
  var value_r = Blockly.JavaScript.valueToCode(block, 'R', Blockly.JavaScript.ORDER_ATOMIC);
  var value_v = Blockly.JavaScript.valueToCode(block, 'V', Blockly.JavaScript.ORDER_ATOMIC);
  var value_b = Blockly.JavaScript.valueToCode(block, 'B', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'couleurCrayon('+value_r+','+value_v+','+value_b+');\n';
  return code;
};
//couleurRemplissage(r,v,b,a)
Blockly.JavaScript['crayon_couleurRemplissage'] = function(block) {
  var value_r = Blockly.JavaScript.valueToCode(block, 'R', Blockly.JavaScript.ORDER_ATOMIC);
  var value_v = Blockly.JavaScript.valueToCode(block, 'V', Blockly.JavaScript.ORDER_ATOMIC);
  var value_b = Blockly.JavaScript.valueToCode(block, 'B', Blockly.JavaScript.ORDER_ATOMIC);
  var value_a = Blockly.JavaScript.valueToCode(block, 'A', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'couleurRemplissage('+value_r+','+value_v+','+value_b+','+value_a+');\n';
  return code;
};
//debutRemplir()
Blockly.JavaScript['crayon_debutRemplir'] = function(block) {
  var code = prefixeAlgoGGB+'debutRemplir();\n';
  return code;
};
//finRemplir()
Blockly.JavaScript['crayon_finRemplir'] = function(block) {
  var code = prefixeAlgoGGB+'finRemplir();\n';
  return code;
};

//Géométrie analytique
//--------------------
//segment(x1,y1,x2,y2)
Blockly.JavaScript['analytique_segment'] = function(block) {
  var value_x1 = Blockly.JavaScript.valueToCode(block, 'X1', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y1 = Blockly.JavaScript.valueToCode(block, 'Y1', Blockly.JavaScript.ORDER_ATOMIC);
  var value_x2 = Blockly.JavaScript.valueToCode(block, 'X2', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y2 = Blockly.JavaScript.valueToCode(block, 'Y2', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'segment('+value_x1+','+value_y1+','+value_x2+','+value_y2+');\n';
  return code;
};
//cercle(x,y,r)
Blockly.JavaScript['analytique_cercle'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var value_r = Blockly.JavaScript.valueToCode(block, 'R', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'cercle('+value_x+','+value_y+','+value_r+');\n';
  return code;
};
//disque(x,y,r)
Blockly.JavaScript['analytique_disque'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var value_r = Blockly.JavaScript.valueToCode(block, 'R', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'disque('+value_x+','+value_y+','+value_r+');\n';
  return code;
};
//arc(x,y,r,a1,a2)
Blockly.JavaScript['analytique_arc'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var value_r = Blockly.JavaScript.valueToCode(block, 'R', Blockly.JavaScript.ORDER_ATOMIC);
  var value_a1 = Blockly.JavaScript.valueToCode(block, 'A1', Blockly.JavaScript.ORDER_ATOMIC);
  var value_a2 = Blockly.JavaScript.valueToCode(block, 'A2', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'arc('+value_x+','+value_y+','+value_r+','+value_a1+','+value_a2+');\n';
  return code;
};
//ellipse(x,y,a,b)
Blockly.JavaScript['analytique_ellipse'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var value_a = Blockly.JavaScript.valueToCode(block, 'A', Blockly.JavaScript.ORDER_ATOMIC);
  var value_b = Blockly.JavaScript.valueToCode(block, 'B', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'ellipse('+value_x+','+value_y+','+value_a+','+value_b+');\n';
  return code;
};
//ellipseRemplie(x,y,a,b)
Blockly.JavaScript['analytique_ellipseRemplie'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var value_a = Blockly.JavaScript.valueToCode(block, 'A', Blockly.JavaScript.ORDER_ATOMIC);
  var value_b = Blockly.JavaScript.valueToCode(block, 'B', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'ellipseRemplie('+value_x+','+value_y+','+value_a+','+value_b+');\n';
  return code;
};
//ecris(x,y,ligne1, ligne2, …)
Blockly.JavaScript['analytique_ecris'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'X', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'Y', Blockly.JavaScript.ORDER_ATOMIC);
  var value_t = Blockly.JavaScript.valueToCode(block, 'T', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'ecrisB('+value_x+','+value_y+','+value_t+');\n';
  return code;
};

//Communication avec GeoGebra
//---------------------------
//initialiser  paramètres
Blockly.JavaScript['geogebra_initialisation'] = function(block) {
  var a = Blockly.JavaScript.valueToCode(block, 'nb_Initial_Objets', Blockly.JavaScript.ORDER_ATOMIC);
  var b = Blockly.JavaScript.valueToCode(block, 'valeurs_A_surveiller', Blockly.JavaScript.ORDER_ATOMIC);
  var c = Blockly.JavaScript.valueToCode(block, 'points_A_surveiller', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'initialiserParam('+a+','+b+','+c+');\n';
  return code;
};
//fixer le nombre initial d'objets
Blockly.JavaScript['geogebra_fixer_nbInitialObjets'] = function(block) {
  var a = Blockly.JavaScript.valueToCode(block, 'nb_Initial_Objets', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixerNbInitialObjets('+a+');\n';
  return code;
};
//fixer les valeurs à surveiller
Blockly.JavaScript['geogebra_fixer_valeursAsurveiller'] = function(block) {
  var a = Blockly.JavaScript.valueToCode(block, 'valeurs_A_surveiller', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixerValeursAsurveiller('+a+');\n';
  return code;
};
//fixer les points à surveiller
Blockly.JavaScript['geogebra_fixer_pointsAsurveiller'] = function(block) {
  var a = Blockly.JavaScript.valueToCode(block, 'points_A_surveiller', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixerPointsAsurveiller('+a+');\n';
  return code;
};
//tracerFigure()
Blockly.JavaScript['geogebra_tracerFigure'] = function(block) {
  var code = prefixeAlgoGGB+'tracerFigure();';
  return code;
};
//retracerFigure()
Blockly.JavaScript['geogebra_retracerFigure'] = function(block) {
  var code = prefixeAlgoGGB+'retracerFigure();';
  return code;
};
//nouveau(debut)
Blockly.JavaScript['geogebra_nouveau'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'nouveau('+value_nom+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//commande(modele,listeNoms)
Blockly.JavaScript['geogebra_commande'] = function(block) {
  var value_chaine = Blockly.JavaScript.valueToCode(block, 'chaine', Blockly.JavaScript.ORDER_ATOMIC);
  var value_params = Blockly.JavaScript.valueToCode(block, 'params', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'commande('+value_chaine+','+value_params+');\n';
  return code;
};
//valeur(nom)
Blockly.JavaScript['geogebra_valeur'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'valeur('+value_nom+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//coordX(nom)
Blockly.JavaScript['geogebra_coordX'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'coordX('+value_nom+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//coordY(nom)
Blockly.JavaScript['geogebra_coordY'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'coordY('+value_nom+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//fixeValeur(nom,valeur)
Blockly.JavaScript['geogebra_fixeValeur'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var value_val = Blockly.JavaScript.valueToCode(block, 'VAL', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixeValeur('+value_nom+','+value_val+');\n';
  return code;
};
//fixeCoords(nom,x,y)
Blockly.JavaScript['geogebra_fixeCoords'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var value_x = Blockly.JavaScript.valueToCode(block, 'VAL1', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'VAL2', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixeCoords('+value_nom+','+value_x+','+value_y+');\n';
  return code;
};
//obtenirNomsDerniersObjets(n)
Blockly.JavaScript['geogebra_obtenirNomsDerniersObjets'] = function(block) {
  var value_n = Blockly.JavaScript.valueToCode(block, 'N', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'obtenirNomsDerniersObjets('+value_n+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};

//Apparence --- Aspect des objets (divers ???)
//----------------
//cacheObjet(nom)
Blockly.JavaScript['apparence_cacheObjet'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'cacheObjet('+value_nom+');\n';
  return code;
};
//cacheEtiquette(nom)
Blockly.JavaScript['apparence_cacheEtiquette'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'cacheEtiquette('+value_nom+');\n';
  return code;
};
//fixeObjet(nom)
Blockly.JavaScript['apparence_fixeObjet'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixeObjet('+value_nom+');\n';
  return code;
};
//montreObjet(nom)
Blockly.JavaScript['apparence_montreObjet'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'montreObjet('+value_nom+');\n';
  return code;
};
//montreEtiquette(nom)
Blockly.JavaScript['apparence_montreEtiquette'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'montreEtiquette('+value_nom+');\n';
  return code;
};
//libereObjet(nom)
Blockly.JavaScript['apparence_libereObjet'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'libereObjet('+value_nom+');\n';
  return code;
};
//colorier(nom,R,V,B)
Blockly.JavaScript['apparence_colorier'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var value_r = Blockly.JavaScript.valueToCode(block, 'R', Blockly.JavaScript.ORDER_ATOMIC);
  var value_v = Blockly.JavaScript.valueToCode(block, 'V', Blockly.JavaScript.ORDER_ATOMIC);
  var value_b = Blockly.JavaScript.valueToCode(block, 'B', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'colorier('+value_nom+','+value_r+','+value_v+','+value_b+');\n';
  return code;
};
//remplir(nom,R,V,B,A)
Blockly.JavaScript['apparence_remplir'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var value_r = Blockly.JavaScript.valueToCode(block, 'R', Blockly.JavaScript.ORDER_ATOMIC);
  var value_v = Blockly.JavaScript.valueToCode(block, 'V', Blockly.JavaScript.ORDER_ATOMIC);
  var value_b = Blockly.JavaScript.valueToCode(block, 'B', Blockly.JavaScript.ORDER_ATOMIC);
  var value_a = Blockly.JavaScript.valueToCode(block, 'A', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'remplir('+value_nom+','+value_r+','+value_v+','+value_b+','+value_a+');\n';
  return code;
};
//fixeEpaisseur(nom,taille)
Blockly.JavaScript['apparence_fixeEpaisseur'] = function(block) {
  var value_nom = Blockly.JavaScript.valueToCode(block, 'NOM', Blockly.JavaScript.ORDER_ATOMIC);
  var value_epais = Blockly.JavaScript.valueToCode(block, 'EPAIS', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'fixeEpaisseur('+value_nom+','+value_epais+');\n';
  return code;
};
// Changer aléatoirement les couleurs
Blockly.JavaScript['apparence_changerCouleurs'] = function(block) {
  var code = prefixeAlgoGGB+'changerCouleursB();\n';
  return code;
};

//Autres commandes
//----------------

//Fonctions
//-------------
//degres(angle)
Blockly.JavaScript['divers_degres'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'x', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'degres('+value_x+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//radians(angle)
Blockly.JavaScript['divers_radians'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'x', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'radians('+value_x+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//hasard(min, max)
Blockly.JavaScript['divers_hasard'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'x', Blockly.JavaScript.ORDER_ATOMIC);
  var value_y = Blockly.JavaScript.valueToCode(block, 'y', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'hasard('+value_x+','+value_y+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//sinD(angle)
Blockly.JavaScript['divers_sinD'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'x', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'sinD('+value_x+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//cosD(angle)
Blockly.JavaScript['divers_cosD'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'x', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'cosD('+value_x+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//tanD(angle)
Blockly.JavaScript['divers_tanD'] = function(block) {
  var value_x = Blockly.JavaScript.valueToCode(block, 'x', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'tanD('+value_x+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
//alerte(ligne1, ligne2, …)
Blockly.JavaScript['divers_alerte'] = function(block) {
  var value_texte = Blockly.JavaScript.valueToCode(block, 'TEXTE', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'alerteB('+value_texte+');';
  return code;
};
//demande(ligne1, ligne2, … , parDéfaut)
Blockly.JavaScript['divers_demande'] = function(block) {
  var value_QUESTION = Blockly.JavaScript.valueToCode(block, 'DEMANDE', Blockly.JavaScript.ORDER_ATOMIC);
  var value_REPONSE = Blockly.JavaScript.valueToCode(block, 'DEFAUT', Blockly.JavaScript.ORDER_ATOMIC);
  var code = prefixeAlgoGGB+'demandeB('+value_QUESTION+','+value_REPONSE+')';
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
// commentaire
Blockly.JavaScript['divers_commentaire'] = function(block) {
  var value_comment = Blockly.JavaScript.valueToCode(block, 'TEXTE', Blockly.JavaScript.ORDER_ATOMIC);
  var code = '// '+value_comment+'\n';
  return code;
};
// variable locale
Blockly.JavaScript['divers_varLocale'] = function(block) {
  var value_var = Blockly.JavaScript.valueToCode(block, 'VAR', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'var '+value_var+';\n';
  return code;
};
//Commande
Blockly.JavaScript['divers_commande'] = function(block) {
  var commande = Blockly.JavaScript.valueToCode(block, 'TEXTE', Blockly.JavaScript.ORDER_ATOMIC);
  var code = 'eval('+commande+');\n';
  return code;
};
//Expression p5
Blockly.JavaScript['divers_expression'] = function(block) {
  var commande = Blockly.JavaScript.valueToCode(block, 'TEXTE', Blockly.JavaScript.ORDER_ATOMIC);
  var code = "eval("+commande+")";
  return [code, Blockly.JavaScript.ORDER_MEMBER];
};
